
SET LOCAL search_path TO @extschema@;

ALTER TYPE pstamp_key RENAME TO actortime_key;
CREATE TYPE ctxactortime_key;

ALTER FUNCTION pstamp_key_in_dummy(cstring) RENAME TO actortime_key_in_dummy;
CREATE OR REPLACE FUNCTION actortime_key_in_dummy(cstring)
  RETURNS actortime_key
  LANGUAGE C IMMUTABLE STRICT
  AS '$libdir/conflux-v0005', 'cfl_notimpl';

CREATE FUNCTION ctxactortime_key_in_dummy(cstring)
  RETURNS ctxactortime_key
  LANGUAGE C IMMUTABLE STRICT
  AS '$libdir/conflux-v0005', 'cfl_notimpl';

ALTER FUNCTION pstamp_key_out_dummy(actortime_key)
  RENAME TO actortime_key_out_dummy;
CREATE OR REPLACE FUNCTION actortime_key_out_dummy(actortime_key)
  RETURNS cstring
  LANGUAGE C IMMUTABLE STRICT
  AS '$libdir/conflux-v0005', 'cfl_notimpl';

CREATE FUNCTION ctxactortime_key_out_dummy(ctxactortime_key)
  RETURNS cstring
  LANGUAGE C IMMUTABLE STRICT
  AS '$libdir/conflux-v0005', 'cfl_notimpl';

CREATE TYPE ctxactortime_key (
  internallength = 40,
  input = ctxactortime_key_in_dummy,
  output = ctxactortime_key_out_dummy,
  alignment = double );


ALTER TYPE pstamp RENAME TO actortime;
CREATE TYPE ctxactortime;
ALTER TYPE pstamp_query RENAME TO ctxactortime_query;

ALTER FUNCTION pstamp_in(cstring) RENAME TO actortime_in;
CREATE OR REPLACE FUNCTION actortime_in(cstring)
  RETURNS actortime
  LANGUAGE C IMMUTABLE STRICT
  AS '$libdir/conflux-v0005', 'cfl_actortime_in';

CREATE FUNCTION ctxactortime_in(cstring)
  RETURNS ctxactortime
  LANGUAGE C IMMUTABLE STRICT
  AS '$libdir/conflux-v0005', 'cfl_ctxactortime_in';

ALTER FUNCTION pstamp_out(actortime) RENAME TO actortime_out;
CREATE OR REPLACE FUNCTION actortime_out(actortime)
  RETURNS cstring
  LANGUAGE C IMMUTABLE STRICT
  AS '$libdir/conflux-v0005', 'cfl_actortime_out';

CREATE FUNCTION ctxactortime_out(ctxactortime)
  RETURNS cstring
  LANGUAGE C IMMUTABLE STRICT
  AS '$libdir/conflux-v0005', 'cfl_ctxactortime_out';

ALTER FUNCTION pstamp_recv(internal) RENAME TO actortime_recv;
CREATE OR REPLACE FUNCTION actortime_recv(internal)
  RETURNS actortime
  LANGUAGE C IMMUTABLE STRICT
  AS '$libdir/conflux-v0005', 'cfl_actortime_recv';

CREATE FUNCTION ctxactortime_recv(internal)
  RETURNS ctxactortime
  LANGUAGE C IMMUTABLE STRICT
  AS '$libdir/conflux-v0005', 'cfl_ctxactortime_recv';

ALTER FUNCTION pstamp_send(actortime) RENAME TO actortime_send;
CREATE OR REPLACE FUNCTION actortime_send(actortime)
  RETURNS bytea
  LANGUAGE C IMMUTABLE STRICT
  AS '$libdir/conflux-v0005', 'cfl_actortime_send';

CREATE FUNCTION ctxactortime_send(ctxactortime)
  RETURNS bytea
  LANGUAGE C IMMUTABLE STRICT
  AS '$libdir/conflux-v0005', 'cfl_ctxactortime_send';

ALTER FUNCTION pstamp_query_in(cstring) RENAME TO ctxactortime_query_in;
CREATE OR REPLACE FUNCTION ctxactortime_query_in(cstring)
  RETURNS ctxactortime_query
  LANGUAGE C IMMUTABLE STRICT
  AS '$libdir/conflux-v0005', 'cfl_ctxactortime_query_in';

ALTER FUNCTION pstamp_query_out(ctxactortime_query)
  RENAME TO ctxactortime_query_out;
CREATE OR REPLACE FUNCTION ctxactortime_query_out(ctxactortime_query)
  RETURNS cstring
  LANGUAGE C IMMUTABLE STRICT
  AS '$libdir/conflux-v0005', 'cfl_ctxactortime_query_out';

CREATE TYPE ctxactortime (
  internallength = 20,
  input = ctxactortime_in,
  output = ctxactortime_out,
  receive = ctxactortime_recv,
  send = ctxactortime_send,
  alignment = double );


ALTER FUNCTION pstamp(int4, int8) RENAME TO actortime;
CREATE OR REPLACE FUNCTION actortime(int4, int8)
  RETURNS actortime
  LANGUAGE C IMMUTABLE STRICT
  AS '$libdir/conflux-v0005', 'cfl_actortime_new';

CREATE FUNCTION ctxactortime(int8, int4, int8)
  RETURNS ctxactortime
  LANGUAGE C IMMUTABLE STRICT
  AS '$libdir/conflux-v0005', 'cfl_ctxactortime_new';

CREATE FUNCTION ctxactortime_query(int8, int4[], int8 = NULL)
  RETURNS ctxactortime_query
  LANGUAGE C IMMUTABLE CALLED ON NULL INPUT
  AS '$libdir/conflux-v0005', 'cfl_ctxactortime_query_new';

CREATE FUNCTION ctxactortime_query(int8, int4, int8 = NULL)
  RETURNS ctxactortime_query
  LANGUAGE SQL IMMUTABLE CALLED ON NULL INPUT
  AS 'SELECT @extschema@.ctxactortime_query($1, ARRAY[$2], $3)';

ALTER FUNCTION pstamp_query(int4[], int8) RENAME TO actortime_query;
CREATE OR REPLACE FUNCTION actortime_query(int4[], int8 = NULL)
  RETURNS ctxactortime_query
  LANGUAGE SQL IMMUTABLE CALLED ON NULL INPUT
  AS 'SELECT @extschema@.ctxactortime_query(0, $1, $2)';

ALTER FUNCTION pstamp_query(int4, int8) RENAME TO actortime_query;
CREATE OR REPLACE FUNCTION actortime_query(int4, int8 = NULL)
  RETURNS ctxactortime_query
  LANGUAGE SQL IMMUTABLE CALLED ON NULL INPUT
  AS 'SELECT @extschema@.ctxactortime_query(0, ARRAY[$1], $2)';


ALTER FUNCTION pstamp_match_proc(actortime, ctxactortime_query)
  RENAME TO actortime_match_proc;
CREATE OR REPLACE FUNCTION actortime_match_proc(actortime, ctxactortime_query)
  RETURNS boolean
  LANGUAGE C IMMUTABLE STRICT
  AS '$libdir/conflux-v0005', 'cfl_actortime_match';

CREATE FUNCTION ctxactortime_match_proc(ctxactortime, ctxactortime_query)
  RETURNS boolean
  LANGUAGE C IMMUTABLE STRICT
  AS '$libdir/conflux-v0005', 'cfl_ctxactortime_match';

CREATE OPERATOR <| (
  leftarg = ctxactortime,
  rightarg = ctxactortime_query,
  procedure = ctxactortime_match_proc,
  commutator = |>,
  restrict = eqsel,
  join = eqjoinsel
);

ALTER FUNCTION pstamp_match_commutator(ctxactortime_query, actortime)
  RENAME TO actortime_match_commutator;
CREATE OR REPLACE FUNCTION actortime_match_commutator
  (ctxactortime_query, actortime)
  RETURNS boolean
  LANGUAGE SQL IMMUTABLE
  AS 'SELECT $2 OPERATOR(@extschema@.<|) $1';

CREATE FUNCTION ctxactortime_match_commutator(ctxactortime_query, ctxactortime)
  RETURNS boolean
  LANGUAGE SQL IMMUTABLE
  AS 'SELECT $2 OPERATOR(@extschema@.<|) $1';

CREATE OPERATOR |> (
  leftarg = ctxactortime_query,
  rightarg = ctxactortime,
  procedure = ctxactortime_match_commutator,
  commutator = <|,
  restrict = eqsel,
  join = eqjoinsel
);

ALTER FUNCTION pstamp_distance_proc(actortime, ctxactortime_query)
  RENAME TO actortime_distance_proc;
CREATE OR REPLACE FUNCTION actortime_distance_proc
  (actortime, ctxactortime_query)
  RETURNS float8
  LANGUAGE C IMMUTABLE STRICT
  AS '$libdir/conflux-v0005', 'cfl_actortime_distance';

CREATE FUNCTION ctxactortime_distance_proc(ctxactortime, ctxactortime_query)
  RETURNS float8
  LANGUAGE C IMMUTABLE STRICT
  AS '$libdir/conflux-v0005', 'cfl_ctxactortime_distance';

CREATE OPERATOR <-| (
  leftarg = ctxactortime,
  rightarg = ctxactortime_query,
  procedure = ctxactortime_distance_proc,
  commutator = |->
);

ALTER FUNCTION pstamp_distance_commutator(ctxactortime_query, actortime)
  RENAME TO actortime_distance_commutator;
CREATE OR REPLACE FUNCTION actortime_distance_commutator
  (ctxactortime_query, actortime)
  RETURNS float8
  LANGUAGE SQL IMMUTABLE
  AS 'SELECT $2 OPERATOR(@extschema@.<-|) $1';

CREATE FUNCTION ctxactortime_distance_commutator
  (ctxactortime_query, ctxactortime)
  RETURNS float8
  LANGUAGE SQL IMMUTABLE
  AS 'SELECT $2 OPERATOR(@extschema@.<-|) $1';

CREATE OPERATOR |-> (
  leftarg = ctxactortime_query,
  rightarg = ctxactortime,
  procedure = ctxactortime_distance_commutator,
  commutator = <-|
);


ALTER FUNCTION cfl_gist_pstamp_consistent(internal)
  RENAME TO cfl_gist_actortime_consistent;
CREATE OR REPLACE FUNCTION cfl_gist_actortime_consistent(internal)
  RETURNS internal
  LANGUAGE C IMMUTABLE STRICT
  AS '$libdir/conflux-v0005', 'cfl_gist_actortime_consistent';

CREATE FUNCTION cfl_gist_ctxactortime_consistent(internal)
  RETURNS internal
  LANGUAGE C IMMUTABLE STRICT
  AS '$libdir/conflux-v0005', 'cfl_gist_ctxactortime_consistent';

ALTER FUNCTION cfl_gist_pstamp_union(internal)
  RENAME TO cfl_gist_actortime_union;
CREATE OR REPLACE FUNCTION cfl_gist_actortime_union(internal)
  RETURNS internal
  LANGUAGE C STRICT
  AS '$libdir/conflux-v0005', 'cfl_gist_actortime_union';

CREATE FUNCTION cfl_gist_ctxactortime_union(internal)
  RETURNS internal
  LANGUAGE C STRICT
  AS '$libdir/conflux-v0005', 'cfl_gist_ctxactortime_union';

ALTER FUNCTION cfl_gist_pstamp_compress(internal)
  RENAME TO cfl_gist_actortime_compress;
CREATE OR REPLACE FUNCTION cfl_gist_actortime_compress(internal)
  RETURNS internal
  LANGUAGE C STRICT
  AS '$libdir/conflux-v0005', 'cfl_gist_actortime_compress';

CREATE FUNCTION cfl_gist_ctxactortime_compress(internal)
  RETURNS internal
  LANGUAGE C STRICT
  AS '$libdir/conflux-v0005', 'cfl_gist_ctxactortime_compress';

CREATE OR REPLACE FUNCTION cfl_gist_decompress(internal)
  RETURNS internal
  LANGUAGE C STRICT
  AS '$libdir/conflux-v0005', 'cfl_gist_decompress';

ALTER FUNCTION cfl_gist_pstamp_penalty(internal)
  RENAME TO cfl_gist_actortime_penalty;
CREATE OR REPLACE FUNCTION cfl_gist_actortime_penalty(internal)
  RETURNS internal
  LANGUAGE C STRICT
  AS '$libdir/conflux-v0005', 'cfl_gist_actortime_penalty';

CREATE FUNCTION cfl_gist_ctxactortime_penalty(internal)
  RETURNS internal
  LANGUAGE C STRICT
  AS '$libdir/conflux-v0005', 'cfl_gist_ctxactortime_penalty';

ALTER FUNCTION cfl_gist_pstamp_picksplit(internal)
  RENAME TO cfl_gist_actortime_picksplit;
CREATE OR REPLACE FUNCTION cfl_gist_actortime_picksplit(internal)
  RETURNS internal
  LANGUAGE C STRICT
  AS '$libdir/conflux-v0005', 'cfl_gist_actortime_picksplit';

CREATE FUNCTION cfl_gist_ctxactortime_picksplit(internal)
  RETURNS internal
  LANGUAGE C STRICT
  AS '$libdir/conflux-v0005', 'cfl_gist_ctxactortime_picksplit';

ALTER FUNCTION cfl_gist_pstamp_same(internal)
  RENAME TO cfl_gist_actortime_same;
CREATE OR REPLACE FUNCTION cfl_gist_actortime_same(internal)
  RETURNS internal
  LANGUAGE C STRICT
  AS '$libdir/conflux-v0005', 'cfl_gist_actortime_same';

CREATE FUNCTION cfl_gist_ctxactortime_same(internal)
  RETURNS internal
  LANGUAGE C STRICT
  AS '$libdir/conflux-v0005', 'cfl_gist_ctxactortime_same';

ALTER FUNCTION cfl_gist_pstamp_distance(internal)
  RENAME TO cfl_gist_actortime_distance;
CREATE OR REPLACE FUNCTION cfl_gist_actortime_distance(internal)
  RETURNS internal
  LANGUAGE C STRICT
  AS '$libdir/conflux-v0005', 'cfl_gist_actortime_distance';

CREATE FUNCTION cfl_gist_ctxactortime_distance(internal)
  RETURNS internal
  LANGUAGE C STRICT
  AS '$libdir/conflux-v0005', 'cfl_gist_ctxactortime_distance';

ALTER OPERATOR CLASS pstamp_ops USING gist RENAME TO actortime_ops;

CREATE OPERATOR CLASS ctxactortime_ops
  DEFAULT FOR TYPE ctxactortime USING gist AS
  OPERATOR 1 <|  (ctxactortime, ctxactortime_query),
  OPERATOR 2 <-| (ctxactortime, ctxactortime_query) FOR ORDER BY float_ops,
  FUNCTION 1 cfl_gist_ctxactortime_consistent(internal),
  FUNCTION 2 cfl_gist_ctxactortime_union(internal),
  FUNCTION 3 cfl_gist_ctxactortime_compress(internal),
  FUNCTION 4 cfl_gist_decompress(internal),
  FUNCTION 5 cfl_gist_ctxactortime_penalty(internal),
  FUNCTION 6 cfl_gist_ctxactortime_picksplit(internal),
  FUNCTION 7 cfl_gist_ctxactortime_same(internal),
  FUNCTION 8 cfl_gist_ctxactortime_distance(internal),
  STORAGE ctxactortime_key;

