
SET LOCAL search_path TO @extschema@;

CREATE TYPE actortime_key;
CREATE TYPE ctxactortime_key;

CREATE FUNCTION actortime_key_in_dummy(cstring)
  RETURNS actortime_key
  LANGUAGE C IMMUTABLE STRICT
  AS '$libdir/conflux-v0005', 'cfl_notimpl';

CREATE FUNCTION ctxactortime_key_in_dummy(cstring)
  RETURNS ctxactortime_key
  LANGUAGE C IMMUTABLE STRICT
  AS '$libdir/conflux-v0005', 'cfl_notimpl';

CREATE FUNCTION actortime_key_out_dummy(actortime_key)
  RETURNS cstring
  LANGUAGE C IMMUTABLE STRICT
  AS '$libdir/conflux-v0005', 'cfl_notimpl';

CREATE FUNCTION ctxactortime_key_out_dummy(ctxactortime_key)
  RETURNS cstring
  LANGUAGE C IMMUTABLE STRICT
  AS '$libdir/conflux-v0005', 'cfl_notimpl';

CREATE TYPE actortime_key (
  internallength = 24,
  input = actortime_key_in_dummy,
  output = actortime_key_out_dummy,
  alignment = double );

CREATE TYPE ctxactortime_key (
  internallength = 40,
  input = ctxactortime_key_in_dummy,
  output = ctxactortime_key_out_dummy,
  alignment = double );


CREATE TYPE actortime;
CREATE TYPE ctxactortime;
CREATE TYPE ctxactortime_query;

CREATE FUNCTION actortime_in(cstring)
  RETURNS actortime
  LANGUAGE C IMMUTABLE STRICT
  AS '$libdir/conflux-v0005', 'cfl_actortime_in';

CREATE FUNCTION ctxactortime_in(cstring)
  RETURNS ctxactortime
  LANGUAGE C IMMUTABLE STRICT
  AS '$libdir/conflux-v0005', 'cfl_ctxactortime_in';

CREATE FUNCTION actortime_out(actortime)
  RETURNS cstring
  LANGUAGE C IMMUTABLE STRICT
  AS '$libdir/conflux-v0005', 'cfl_actortime_out';

CREATE FUNCTION ctxactortime_out(ctxactortime)
  RETURNS cstring
  LANGUAGE C IMMUTABLE STRICT
  AS '$libdir/conflux-v0005', 'cfl_ctxactortime_out';

CREATE FUNCTION actortime_recv(internal)
  RETURNS actortime
  LANGUAGE C IMMUTABLE STRICT
  AS '$libdir/conflux-v0005', 'cfl_actortime_recv';

CREATE FUNCTION ctxactortime_recv(internal)
  RETURNS ctxactortime
  LANGUAGE C IMMUTABLE STRICT
  AS '$libdir/conflux-v0005', 'cfl_ctxactortime_recv';

CREATE FUNCTION actortime_send(actortime)
  RETURNS bytea
  LANGUAGE C IMMUTABLE STRICT
  AS '$libdir/conflux-v0005', 'cfl_actortime_send';

CREATE FUNCTION ctxactortime_send(ctxactortime)
  RETURNS bytea
  LANGUAGE C IMMUTABLE STRICT
  AS '$libdir/conflux-v0005', 'cfl_ctxactortime_send';

CREATE FUNCTION ctxactortime_query_in(cstring)
  RETURNS ctxactortime_query
  LANGUAGE C IMMUTABLE STRICT
  AS '$libdir/conflux-v0005', 'cfl_ctxactortime_query_in';

CREATE FUNCTION ctxactortime_query_out(ctxactortime_query)
  RETURNS cstring
  LANGUAGE C IMMUTABLE STRICT
  AS '$libdir/conflux-v0005', 'cfl_ctxactortime_query_out';

CREATE TYPE actortime (
  internallength = 12,
  input = actortime_in,
  output = actortime_out,
  receive = actortime_recv,
  send = actortime_send,
  alignment = double );

CREATE TYPE ctxactortime (
  internallength = 20,
  input = ctxactortime_in,
  output = ctxactortime_out,
  receive = ctxactortime_recv,
  send = ctxactortime_send,
  alignment = double );

CREATE TYPE ctxactortime_query (
  internallength = VARIABLE,
  input = ctxactortime_query_in,
  output = ctxactortime_query_out,
  alignment = double,
  storage = external );


CREATE FUNCTION actortime(int4, int8)
  RETURNS actortime
  LANGUAGE C IMMUTABLE STRICT
  AS '$libdir/conflux-v0005', 'cfl_actortime_new';

CREATE FUNCTION ctxactortime(int8, int4, int8)
  RETURNS ctxactortime
  LANGUAGE C IMMUTABLE STRICT
  AS '$libdir/conflux-v0005', 'cfl_ctxactortime_new';

CREATE FUNCTION ctxactortime_query(int8, int4[], int8 = NULL)
  RETURNS ctxactortime_query
  LANGUAGE C IMMUTABLE CALLED ON NULL INPUT
  AS '$libdir/conflux-v0005', 'cfl_ctxactortime_query_new';

CREATE FUNCTION ctxactortime_query(int8, int4, int8 = NULL)
  RETURNS ctxactortime_query
  LANGUAGE SQL IMMUTABLE CALLED ON NULL INPUT
  AS 'SELECT @extschema@.ctxactortime_query($1, ARRAY[$2], $3)';

CREATE FUNCTION actortime_query(int4[], int8 = NULL)
  RETURNS ctxactortime_query
  LANGUAGE SQL IMMUTABLE CALLED ON NULL INPUT
  AS 'SELECT @extschema@.ctxactortime_query(0, $1, $2)';

CREATE FUNCTION actortime_query(int4, int8 = NULL)
  RETURNS ctxactortime_query
  LANGUAGE SQL IMMUTABLE CALLED ON NULL INPUT
  AS 'SELECT @extschema@.ctxactortime_query(0, ARRAY[$1], $2)';


CREATE FUNCTION actortime_match_proc(actortime, ctxactortime_query)
  RETURNS boolean
  LANGUAGE C IMMUTABLE STRICT
  AS '$libdir/conflux-v0005', 'cfl_actortime_match';

CREATE FUNCTION ctxactortime_match_proc(ctxactortime, ctxactortime_query)
  RETURNS boolean
  LANGUAGE C IMMUTABLE STRICT
  AS '$libdir/conflux-v0005', 'cfl_ctxactortime_match';

CREATE OPERATOR <| (
  leftarg = actortime,
  rightarg = ctxactortime_query,
  procedure = actortime_match_proc,
  commutator = |>,
  restrict = eqsel,
  join = eqjoinsel
);

CREATE OPERATOR <| (
  leftarg = ctxactortime,
  rightarg = ctxactortime_query,
  procedure = ctxactortime_match_proc,
  commutator = |>,
  restrict = eqsel,
  join = eqjoinsel
);

CREATE FUNCTION actortime_match_commutator(ctxactortime_query, actortime)
  RETURNS boolean
  LANGUAGE SQL IMMUTABLE
  AS 'SELECT $2 OPERATOR(@extschema@.<|) $1';

CREATE FUNCTION ctxactortime_match_commutator(ctxactortime_query, ctxactortime)
  RETURNS boolean
  LANGUAGE SQL IMMUTABLE
  AS 'SELECT $2 OPERATOR(@extschema@.<|) $1';

CREATE OPERATOR |> (
  leftarg = ctxactortime_query,
  rightarg = actortime,
  procedure = actortime_match_commutator,
  commutator = <|,
  restrict = eqsel,
  join = eqjoinsel
);

CREATE OPERATOR |> (
  leftarg = ctxactortime_query,
  rightarg = ctxactortime,
  procedure = ctxactortime_match_commutator,
  commutator = <|,
  restrict = eqsel,
  join = eqjoinsel
);

CREATE FUNCTION actortime_distance_proc(actortime, ctxactortime_query)
  RETURNS float8
  LANGUAGE C IMMUTABLE STRICT
  AS '$libdir/conflux-v0005', 'cfl_actortime_distance';

CREATE FUNCTION ctxactortime_distance_proc(ctxactortime, ctxactortime_query)
  RETURNS float8
  LANGUAGE C IMMUTABLE STRICT
  AS '$libdir/conflux-v0005', 'cfl_ctxactortime_distance';

CREATE OPERATOR <-| (
  leftarg = actortime,
  rightarg = ctxactortime_query,
  procedure = actortime_distance_proc,
  commutator = |->
);

CREATE OPERATOR <-| (
  leftarg = ctxactortime,
  rightarg = ctxactortime_query,
  procedure = ctxactortime_distance_proc,
  commutator = |->
);

CREATE FUNCTION actortime_distance_commutator(ctxactortime_query, actortime)
  RETURNS float8
  LANGUAGE SQL IMMUTABLE
  AS 'SELECT $2 OPERATOR(@extschema@.<-|) $1';

CREATE FUNCTION ctxactortime_distance_commutator
  (ctxactortime_query, ctxactortime)
  RETURNS float8
  LANGUAGE SQL IMMUTABLE
  AS 'SELECT $2 OPERATOR(@extschema@.<-|) $1';

CREATE OPERATOR |-> (
  leftarg = ctxactortime_query,
  rightarg = actortime,
  procedure = actortime_distance_commutator,
  commutator = <-|
);

CREATE OPERATOR |-> (
  leftarg = ctxactortime_query,
  rightarg = ctxactortime,
  procedure = ctxactortime_distance_commutator,
  commutator = <-|
);


CREATE FUNCTION cfl_gist_actortime_consistent(internal)
  RETURNS internal
  LANGUAGE C IMMUTABLE STRICT
  AS '$libdir/conflux-v0005', 'cfl_gist_actortime_consistent';

CREATE FUNCTION cfl_gist_ctxactortime_consistent(internal)
  RETURNS internal
  LANGUAGE C IMMUTABLE STRICT
  AS '$libdir/conflux-v0005', 'cfl_gist_ctxactortime_consistent';

CREATE FUNCTION cfl_gist_actortime_union(internal)
  RETURNS internal
  LANGUAGE C STRICT
  AS '$libdir/conflux-v0005', 'cfl_gist_actortime_union';

CREATE FUNCTION cfl_gist_ctxactortime_union(internal)
  RETURNS internal
  LANGUAGE C STRICT
  AS '$libdir/conflux-v0005', 'cfl_gist_ctxactortime_union';

CREATE FUNCTION cfl_gist_actortime_compress(internal)
  RETURNS internal
  LANGUAGE C STRICT
  AS '$libdir/conflux-v0005', 'cfl_gist_actortime_compress';

CREATE FUNCTION cfl_gist_ctxactortime_compress(internal)
  RETURNS internal
  LANGUAGE C STRICT
  AS '$libdir/conflux-v0005', 'cfl_gist_ctxactortime_compress';

CREATE FUNCTION cfl_gist_decompress(internal)
  RETURNS internal
  LANGUAGE C STRICT
  AS '$libdir/conflux-v0005', 'cfl_gist_decompress';

CREATE FUNCTION cfl_gist_actortime_penalty(internal)
  RETURNS internal
  LANGUAGE C STRICT
  AS '$libdir/conflux-v0005', 'cfl_gist_actortime_penalty';

CREATE FUNCTION cfl_gist_ctxactortime_penalty(internal)
  RETURNS internal
  LANGUAGE C STRICT
  AS '$libdir/conflux-v0005', 'cfl_gist_ctxactortime_penalty';

CREATE FUNCTION cfl_gist_actortime_picksplit(internal)
  RETURNS internal
  LANGUAGE C STRICT
  AS '$libdir/conflux-v0005', 'cfl_gist_actortime_picksplit';

CREATE FUNCTION cfl_gist_ctxactortime_picksplit(internal)
  RETURNS internal
  LANGUAGE C STRICT
  AS '$libdir/conflux-v0005', 'cfl_gist_ctxactortime_picksplit';

CREATE FUNCTION cfl_gist_actortime_same(internal)
  RETURNS internal
  LANGUAGE C STRICT
  AS '$libdir/conflux-v0005', 'cfl_gist_actortime_same';

CREATE FUNCTION cfl_gist_ctxactortime_same(internal)
  RETURNS internal
  LANGUAGE C STRICT
  AS '$libdir/conflux-v0005', 'cfl_gist_ctxactortime_same';

CREATE FUNCTION cfl_gist_actortime_distance(internal)
  RETURNS internal
  LANGUAGE C STRICT
  AS '$libdir/conflux-v0005', 'cfl_gist_actortime_distance';

CREATE FUNCTION cfl_gist_ctxactortime_distance(internal)
  RETURNS internal
  LANGUAGE C STRICT
  AS '$libdir/conflux-v0005', 'cfl_gist_ctxactortime_distance';

CREATE OPERATOR CLASS actortime_ops
  DEFAULT FOR TYPE actortime USING gist AS
  OPERATOR 1 <|  (actortime, ctxactortime_query),
  OPERATOR 2 <-| (actortime, ctxactortime_query) FOR ORDER BY float_ops,
  FUNCTION 1 cfl_gist_actortime_consistent(internal),
  FUNCTION 2 cfl_gist_actortime_union(internal),
  FUNCTION 3 cfl_gist_actortime_compress(internal),
  FUNCTION 4 cfl_gist_decompress(internal),
  FUNCTION 5 cfl_gist_actortime_penalty(internal),
  FUNCTION 6 cfl_gist_actortime_picksplit(internal),
  FUNCTION 7 cfl_gist_actortime_same(internal),
  FUNCTION 8 cfl_gist_actortime_distance(internal),
  STORAGE actortime_key;

CREATE OPERATOR CLASS ctxactortime_ops
  DEFAULT FOR TYPE ctxactortime USING gist AS
  OPERATOR 1 <|  (ctxactortime, ctxactortime_query),
  OPERATOR 2 <-| (ctxactortime, ctxactortime_query) FOR ORDER BY float_ops,
  FUNCTION 1 cfl_gist_ctxactortime_consistent(internal),
  FUNCTION 2 cfl_gist_ctxactortime_union(internal),
  FUNCTION 3 cfl_gist_ctxactortime_compress(internal),
  FUNCTION 4 cfl_gist_decompress(internal),
  FUNCTION 5 cfl_gist_ctxactortime_penalty(internal),
  FUNCTION 6 cfl_gist_ctxactortime_picksplit(internal),
  FUNCTION 7 cfl_gist_ctxactortime_same(internal),
  FUNCTION 8 cfl_gist_ctxactortime_distance(internal),
  STORAGE ctxactortime_key;

